#ifndef _FTYPES_H_
#define _FTYPES_H_

#ifdef WIN32
#   define FATR __stdcall
#else
#   define FATR 
#endif

#if   SIZEOF_F77_INTEGER == SIZEOF_INT
typedef int Integer;
#elif SIZEOF_F77_INTEGER == SIZEOF_LONG
typedef long Integer;
#elif SIZEOF_F77_INTEGER == SIZEOF_LONG_LONG
typedef long long Integer;
#else
#   error
#endif

#if   SIZEOF_F77_REAL == SIZEOF_FLOAT
typedef float Real;
#elif SIZEOF_F77_REAL == SIZEOF_DOUBLE
typedef double Real;
#elif SIZEOF_F77_REAL == SIZEOF_LONG_DOUBLE
typedef long double Real;
#else
#   error
#endif

#if   SIZEOF_F77_DOUBLE_PRECISION == SIZEOF_FLOAT
typedef float DoublePrecision;
#elif SIZEOF_F77_DOUBLE_PRECISION == SIZEOF_DOUBLE
typedef double DoublePrecision;
#elif SIZEOF_F77_DOUBLE_PRECISION == SIZEOF_LONG_DOUBLE
typedef long double DoublePrecision;
#else
#   error
#endif

typedef Integer Logical;

typedef struct {
    DoublePrecision real;
    DoublePrecision imag;
} DoubleComplex;

typedef struct {
    Real real;
    Real imag;
} SingleComplex;

#if   SIZEOF_VOIDP == SIZEOF_INT
typedef int AccessIndex;
#elif SIZEOF_VOIDP == SIZEOF_LONG
typedef long AccessIndex;
#elif SIZEOF_VOIDP == SIZEOF_LONG_LONG
typedef long long AccessIndex;
#else
#   error
#endif

#endif /* _FTYPES_H_ */
