/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_BACKENDS_OMNETPP_NODE_NIC_CYCLEACCURATENIC_PACKETDISP_H_INCLUDED
#define SSTMAC_BACKENDS_OMNETPP_NODE_NIC_CYCLEACCURATENIC_PACKETDISP_H_INCLUDED

#include <omnetpp.h>

#include <node_m.h>

#include <node/nic/nic.h>

#include <queue>

namespace sstmac { namespace omnetpp {

  class cycleaccuratenic_packetdisp: public nic {
  protected:
    virtual void initialize();
    virtual void handleMessage(cMessage *msg);
    virtual void finish();


    void try_net_Q();
    //void send_proc_ack(ApplicationMsg* coreMsg);
    void next_packet();

    cGate* fromProc;
    cGate* toProc;
    cGate* fromNet;
    cGate* toNet;

    cMessage* nextPacketMsg;

    CoreMsg* currentMsg;
    int currentRoute_;
    int sent;

    cPacketQueue netQ;

    int mtu;

    int nextVC_;
    int numVC_;

    std::map<int, int> credits_;

    std::map<long, long> packets_recv_;

    cPacketQueue credAckQ_;
    long numPackets;
    static long UID_counter;
    long uid_;

  };
} }
#endif
