//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
// 

#include "ib_mellanox_nic.h"

#include "network_m.h"

namespace sstmac { namespace omnetpp {


  Define_Module(IB_Mellanox_NIC)
    ;

  void
  IB_Mellanox_NIC::initialize()
  {
    fromProc = gate("toProcessor$i", 0);
    toProc = gate("toProcessor$o", 0);
    fromNet = gate("toNetwork$i", 0);
    toNet = gate("toNetwork$o", 0);

  }

  void
  IB_Mellanox_NIC::finish()
  {

  }

  void
  IB_Mellanox_NIC::handleMessage(cMessage *cmsg)
  {
    if (cmsg->isSelfMessage())
      {

      }
    else
      {
        cGate* arrivalGate = cmsg->getArrivalGate();
        if (arrivalGate == fromProc)
          {
            gen_->handleMessage(cmsg);
          }
        else if (arrivalGate == fromNet)
          {
            sink_->handleMessage(cmsg);
          }
      }
  }

} }
