//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
// 
// You should have received a copy of the GNU Lesser General Public License
// along with this program.  If not, see http://www.gnu.org/licenses/.
// 

#ifndef SSTMAC_BACKENDS_OMNETPP_THIRDPARTY_IB_MELLANOX_IB_MELLANOX_NIC_H_INCLUDED
#define SSTMAC_BACKENDS_OMNETPP_THIRDPARTY_IB_MELLANOX_IB_MELLANOX_NIC_H_INCLUDED

#include <omnetpp.h>

#include <sstmac/backends/omnetpp/node_m.h>

#include <sstmac/backends/omnetpp/node/nic/nic.h>

#include "ib_m.h"

#include "gen.h"
#include "sink.h"

namespace sstmac { namespace omnetpp {

  class IB_Mellanox_NIC: public nic {
  protected:
    virtual void initialize();
    virtual void handleMessage(cMessage *msg);
    virtual void finish();

    void send_proc_ack(ApplicationMsg* appMsg);

    cGate* fromProc;
    cGate* toProc;
    cGate* fromNet;
    cGate* toNet;


    IBGenerator* gen_;
    IBSink* sink_;
  };
} }
#endif
