/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/common/nodeaddress.h>

namespace sstmac
{

  nodeaddress::address_converter::ptr nodeaddress::converter_;

  bool
  operator==(const nodeaddress::ptr &a, const nodeaddress::ptr &b)
  {
    return (a->equals(b));
  }

  bool
  operator!=(const nodeaddress::ptr &a, const nodeaddress::ptr &b)
  {
    return (!a->equals(b));
  }

}

namespace boost
{
  size_t
  hash_value(const sstmac::nodeaddress::ptr &t)
  {
   // std::cout << "calling hash_value, returning " << t->unique_id()
   //     << std::endl;
    return t->unique_id();
  }
}
