#include <sstmac/common/stats/stats_common.h>

namespace sstmac {

void
stat_spyplot::add_one(long source, long dest)
{
  if (is_active())
    {
      /** 
      if (vals_.find(source) == vals_.end())
        {
          vals_[source] = std::map<long, long>();
          for (long i = 0; i < num_; i++)
            {
              vals_[source][i] = 0;
            }
        }
      */
      //We don't need to fill. This by default will insert a zero element.
      vals_[source][dest] += 1;
    }
}

void
stat_spyplot::add(long source, long dest, long num)
{
  if (is_active())
    {
      /**
      if (vals_.find(source) == vals_.end())
        {
          vals_[source] = std::map<long, long>();
          for (long i = 0; i < num_; i++)
            {
              vals_[source][i] = 0;
            }
        }
      */
      //We don't need to fill. This by default will insert a zero element.
      vals_[source][dest] += num;
    }
}

void
stat_spyplot::simulation_finished(timestamp end)
{
  if (is_active() && check_open())
    {
     /* myfile << "stat_sum(" << signature_ << ") \n\n";

      //print header
      for (long i = 0; i < num_; i++)
        {
          myfile << ", " << i;
        }
      myfile << "\n";*/

      long count = 0;
      std::list<long> nodes;

      {
          std::map<long, std::map<long, long> >::iterator it, end = vals_.end();
          for (it = vals_.begin(); it != end; it++)
          {
            nodes.push_back(it->first);
          }
      }

      nodes.sort();

      std::list<long>::const_iterator it = nodes.begin(), end = nodes.end();
      for ( ; it != end; ++it)
      {
          std::map<long, long>& submap = vals_[*it];
          std::list<long>::const_iterator it2 = nodes.begin(), end2 = nodes.end();
          long datapoint = submap[*it2];
          myfile << datapoint;
          ++it2;
          for ( ; it2 != end2; ++it2)
          {
              long datapoint = submap[*it2];
              myfile << "," << datapoint;
          }
          myfile << "\n";
       }

      myfile.close();
    }
}

} //end namespace

