/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */
#ifndef SSTMAC_HARDWARE_FAILURE_FAILURE_EVENT_H_INCLUDED
#define SSTMAC_HARDWARE_FAILURE_FAILURE_EVENT_H_INCLUDED

#include <sstmac/common/messages/sst_message.h>

namespace sstmac
{
  namespace hw
  {
    class failure_event : public sst_message
    {
    protected:
      failure_event() : sst_message(sst_message::FAILURE)
      {

      }

    public:
      typedef boost::intrusive_ptr<failure_event> ptr;

      virtual
      ~failure_event() { }

      static ptr
      construct(){
        return ptr(new failure_event());
      }

      virtual std::string
      to_string() const {
        return "failure_event";
      }
    };
  }
}

#endif
