/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/hardware/memory/memorymodel.h>

namespace sstmac
{
  namespace hw
  {

    debug memorymodel::dbg_;

    memorymodel::memorymodel(long nodeid) :
      nodeid_(nodeid)
    {
      if (!dbg_.is_real())
        {
          dbg_ = debug("<debug> memory");
          logger::register_logger(&dbg_);
        }

    }

    timestamp
    memorymodel::link::new_access(long size)
    {
      current_accesses_++;

      return lat_ + timestamp((double)size * ((double)current_accesses_ / bw_));
    }

    void
    memorymodel::link::access_done(){
      current_accesses_--;
    }

  }
} /* namespace sstmac */
