/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/hardware/processor/computescheduler.h>

namespace sstmac
{
  namespace hw
  {

    using namespace std;

    debug computescheduler::dbg_;

    computescheduler::computescheduler(long nodeid, int ncores, timestamp preempt) :
        n_cores_(ncores), nodeid_(nodeid), preemption_(preempt)
    {
      if (!dbg_.is_real())
        {
          dbg_ = debug("<debug> computescheduler");
          logger::register_logger(&dbg_);
        }

    }


  }
} //end of namespace sstmac
