/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */


#include <sstmac/software/ami/environment.h>

#include <sstmac/common/errors.h>

#include <boost/foreach.hpp>

namespace sstmac { namespace sw
{

  
  

  environment::environment()
  {


  }

  environment::~environment()
  {

  }

  //
  // Allocate an object of this type.
  //
  environment::ptr
  environment::construct()
  {
    environment::ptr retval(new environment());
    //retval->set_self(retval);
    return retval;
  }



  void
  environment::serialize(sst_serializer* ser)
  {
    //first say how big it is
    size_t s = mapping_.size();
    ser->pack(s);

  //  std::map<taskid, nodeaddress::ptr >::iterator it, end =
  //      mapping_.end();

    BOOST_FOREACH (map_type::value_type it, mapping_)
      {
        ser->pack(it.first.id);
        it.second->serialize(ser);
      }
  }
  environment::ptr
  environment::deserialize(sst_serializer* ser)
  {

    environment::ptr ret = environment::construct();
    size_t s;
    ser->unpack(s);

    for (size_t i = 0; i < s; i++)
      {
        int t;
        ser->unpack(t);
        taskid task(t);


        nodeaddress::ptr n = ser->get_deser_addr();
        n->deserialize(ser);

        ret->add_item(task, n);
      }

    return ret;
  }

} } //end of namespace sstmac
