/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_SOFTWARE_LIBRARIES_HPX_COMPONENTS_HPX_STUBS_H_INCLUDED
#define SSTMAC_SOFTWARE_LIBRARIES_HPX_COMPONENTS_HPX_STUBS_H_INCLUDED


#include <sstmac/common/sizeable.h>
#include <hpx/agas/globalid.h>

namespace hpx
{
  namespace components
  {

    class hpx_stubs : public sstmac::sizeable
    {
    protected:
      hpx_stubs(globalid gid) : gid_(gid) {

      }

      globalid gid_;

    public:
      typedef boost::intrusive_ptr<hpx_stubs> ptr;

      virtual std::string
      to_string() const {
        return "hpx_stubs";
      }

      virtual
      ~hpx_stubs() { }

      virtual long
      get_byte_length() const {
        return sizeof(globalid);
      }
    };

  }
}

#endif
