/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_SOFTWARE_LIBRARIES_HPX_LCOS_BASE_LCO_RESULT_H_INCLUDED
#define SSTMAC_SOFTWARE_LIBRARIES_HPX_LCOS_BASE_LCO_RESULT_H_INCLUDED

#include <hpx/lcos/lco.h>
#include <sstmac/common/messages/payload.h>

namespace hpx
{
  namespace lcos
  {

    class base_lco_result : public lco
    {

    protected:

      base_lco_result()
      {

      }

     /* base_lco_result(sstmac::sw::OS_API::ptr os) :
          lco(os)
      {

      }*/

    public:
      typedef boost::intrusive_ptr<base_lco_result> ptr;

      virtual
      ~base_lco_result()
      {
      }

      virtual sstmac::payload::const_ptr
      get_value() = 0;
      virtual void
      set_value(sstmac::payload::const_ptr res, sstmac::sw::OS_API::ptr os) = 0;
    };
  }
}

#endif
