/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_SOFTWARE_LIBRARIES_HPX_LCOS_HPX_CALLBACK_H_INCLUDED
#define SSTMAC_SOFTWARE_LIBRARIES_HPX_LCOS_HPX_CALLBACK_H_INCLUDED

#include <hpx/lcos/lco.h>
#include <hpx/runtime/actions/hpx_action_params.h>

namespace hpx
{
  namespace lcos
  {

    template<typename ResultType>
      class hpx_callback : public lco
      {

      public:
        typedef boost::intrusive_ptr<hpx_callback> ptr;

        virtual
        ~hpx_callback()
        {
        }

        ResultType
        operator()(hpx_action_params::ptr params)
        {
          return func(params);
        }

        virtual ResultType
        func(hpx_action_params::ptr params) = 0;
      };


  }

}

#endif
