/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_SOFTWARE_LIBRARIES_MPI_MPI_COMM_MPICOMMDATA_H_INCLUDED
#define SSTMAC_SOFTWARE_LIBRARIES_MPI_MPI_COMM_MPICOMMDATA_H_INCLUDED

#include <sstmac/software/libraries/mpi/mpi_comm/mpicommid.h>
#include <sstmac/software/process/taskid.h>

#include <sstmac/software/ami/environment.h>
#include <sstmac/software/libraries/mpi/mpi_types/mpiid.h>
#include <sstmac/software/process/appid.h>
#include <sstmac/software/process/softwareid.h>
#include <sstmac/software/process/taskid.h>
#include <sstmac/common/nocopy.h>

#include <sstmac/common/ptr_type.h>

#include <vector>

namespace sstmac { namespace sw
{

  /**
   * Shared data for a communicator.
   *
   * There is no guarantee that this object will be shared by all instances
   * of a communicator (eventually we will want to move to a distributed
   * simulator), but it is best to ensure that the communicator data
   * is not replicted any more than it needs to be.
   */
  /*class mpicommdata : virtual public nocopy
  {
    friend class mpicomm;

    /// A reference-count replacement for 'this' object pointer.
    boost::weak_ptr<mpicommdata> self_;

    /// The identifier for this communicator.
    mpicommid id_;

    /// The tasks participating in this communicator.
   //// const std::vector<taskid> peers_;

    /// The nodes participating in this communicator.
    ////const std::vector<nodeid> nodes_;



    appid appid_;

  protected:
    /// Hello.
    mpicommdata(mpicommid id, const environment::ptr &env);

    /// Who am I?
    void
    set_self(const mpicommdata::ptr& self);

    /// This is who I am.
    mpicommdata::ptr
    self();

  public:
    /// Build a new object.
    static mpicommdata::ptr
    construct(const mpicommid &id, const environment::ptr &env);
    ////const std::vector<nodeid> &nodes);

    /// Goodbye.
    virtual
    ~mpicommdata();

    /// My identifier.
    const mpicommid&
    id() const
    {
      return id_;
    }



    /// The nodes each peer is running on.
     const nodeaddress::ptr nodeAt(taskid &tid) {
       softwareid sid(appid_, tid);
       return env_->get_node_address(sid);
     }
  };*/

  class mpicommdata : public ptr_type {
  public:
    typedef boost::intrusive_ptr<mpicommdata> ptr;

    virtual std::string to_string() const{
            return "mpicommdata";
          }
  };

} } // end of namespace sstmac

#endif
