/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/software/skeletons/test/test_compute_f.h>

extern "C" {
  void test_compute_f90_();
}

namespace sstmac { namespace sw
{
  using namespace std;
  

  test_compute_f::test_compute_f(softwareid id) :
    app(id)
  {


  }

  // Build a new minimd object.
  //
  test_compute_f::ptr
  test_compute_f::construct(softwareid id)
  {
    test_compute_f::ptr retval(new test_compute_f(id));
    // retval->set_self(retval);
    return retval;
  }

  void
  test_compute_f::consume_params(const sim_parameters::ptr &params)
  {

  }

  //
  // Get a copy of this object.
  //
  app::ptr
  test_compute_f::clone(softwareid id)
  {
    return construct(id);
  }

  test_compute_f::~test_compute_f()
  {

  }

  void
  test_compute_f::skeleton_main()
  {
    SSTMAC_DEBUG << "t=" << now() << ": Hello World, i'm computer number "
                 << id_.task_.id << ", about to begin computing.\n";

    // test the F90 compute interface
    // it takes some finesse for C++ to call into Fortran, hardwire for now
    timestamp tstart( now() );
    test_compute_f90_();
    timestamp tstop( now() );
    std::cout << "F90 compute test consumed " << tstop - tstart << "\n";

  }

} } //end of namespace sstmac
