#ifndef SDMA_DISK_LIB_H_
#define SDMA_DISK_LIB_H_

#include "sdma_lib.h"

#include <sstmac/software/libraries/filesystem/nppfs.h>

namespace sdma
{

  class sdma_disk_lib : public sdma_lib
  {

  protected:

    sstmac::sw::nppfs::ptr pfs_;
    sstmac::sw::openfile::ptr file_;

    sdma_disk_lib(sstmac::sw::softwareid id) : sdma_lib(id)
    {

    }

  public:
    typedef boost::intrusive_ptr<sdma_lib> ptr;

    static ptr
    construct(sstmac::sw::softwareid id)
    {
      return ptr(new sdma_disk_lib(id));
    }

    virtual void
    process_data(long bytes);

    virtual
    ~sdma_disk_lib()
    {
    }

    virtual void
    register_child_libs(){
      pfs_ = sstmac::sw::nppfs::construct("nppfs-" + libname_);
      register_lib(pfs_);
    }
  };

}

#endif
