#ifndef SDMA_DISK_SERVER_H_
#define SDMA_DISK_SERVER_H_

#include <sstmac/software/services/service.h>
#include "sdma_work_lib.h"
#include <sstmac/software/libraries/filesystem/nppfs.h>
#include <queue>
#include "sdma_message.h"
#include "sdma_analysis_server.h"

namespace sdma
{

  class sdma_disk_server : public sdma_analysis_server
  {
  protected:

    long writing_bytes_;
    sstmac::nodeaddress::ptr writing_to_;

    sdma_disk_server()
    {
      work_msg_ = sstmac::sst_message::construct(get_server_name(),
               sstmac::timestamp(1e-9), sstmac::sst_message::SDMA, 0);
      libname_ = get_server_name();
    }

  public:
    typedef boost::intrusive_ptr<sdma_disk_server> ptr;

    static ptr
    construct()
    {
      return ptr(new sdma_disk_server());
    }

    virtual service::ptr
    clone()
    {
      return construct();
    }

    static std::string
    get_server_name()
    {
      return "sdma_disk_server";
    }

    virtual
    ~sdma_disk_server()
    {
    }

    virtual std::string
    to_string() const
    {
      return "sdma_disk_server";
    }


    virtual void
    handle_pfs(const sstmac::sw::file_metadata::ptr &msg);

    virtual void
    work();

    virtual void
    send_along(long bytes, sstmac::nodeaddress::ptr next);

  };

}

#endif
