#include "sdma_lib.h"

using namespace sstmac;
using namespace sstmac::sw;

namespace sdma
{
  debug sdma_lib::dbg_;
  sdma_analysis_node_config::ptr sdma_lib::config_;

  void
  sdma_lib::init_sdma(int stages, double conc)
  {
    if (!config_)
      {
        environment::const_ptr env = os_->get_env(id_.app_);
        std::list<nodeaddress::ptr> extras = env->get_extras();
        long appsize = env->get_app_count();

        if (extras.size() == 0)
          {
            throw ssterror(
                "sdma_lib::init_sdma -- need to allocate extra nodes for analysis/staging");
          }

        std::vector<int> levs(stages, 0);
        long left = extras.size();
        long prev;
        levs[0] = 1;
        left--;

        for (int i = stages-1; i >= 1; i--)
          {
            long n;
            if (i == stages-1)
              {
                n = conc * appsize;
              }else{
                n = conc * prev;
              }

            if (n > left)
              {
                std::cout << "--- stage: " << i << "\n";
                throw ssterror(
                    "sdma_lib::init_sdma - don't have enough extra nodes for stage");
              }

            levs[i] = n;
            left -= n;

            prev = n;
          }

        config_ = sdma_analysis_node_config::construct(levs, extras, appsize);
      }
  }
}
