#include "sdma_staged_server.h"
#include "sdma_message.h"
#include <sstmac/sstmacro.h>
#include "sdma_lib.h"

using namespace sstmac;
using namespace sstmac::sw;

namespace sdma
{
  SSTRegisterServ("sdma_staged_server", sdma_staged_server)
  ;

  void
  sdma_staged_server::work()
  {
    if (!working_)
      {
        if (work_queue_.size() > 0)
          {
            working_ = true;
            sdma_message::ptr smsg = work_queue_.front();

            SSTMAC_DEBUG << "sdma_server[" << myaddr_->to_string() << "]: working on a go-staged message \n";

            sdma_go_staged::ptr go =
                boost::dynamic_pointer_cast<sdma_go_staged>(smsg);
            //we can work right away cause we already have the data
            work_->mem_access(go->get_work_bytes());

          }
      }
  }

  void
  sdma_staged_server::send_along(long bytes, sstmac::nodeaddress::ptr next)
  {
    sdma_go_staged::ptr mess = sdma_go_staged::construct(bytes);

    mess->toaddr_ = next;
    mess->set_lib_name(get_server_name());
    mess->set_needs_ack(false);

    os_->execute_kernel(AMI::AMI_COMM, AMI::AMI_COMM_SEND, mess);

    work_done();
  }

}
